d("checkoutPageView",['util',], function(UTIL,checkoutPageView) {

    return {
        extendCheckoutPageView: function() {
            CCRZ.remoteActions = _.extend(CCRZ.remoteActions||{});
            
            CCRZ.remoteActions.checkoutPageRemoting =  _.extend(CCRZ.RemoteInvocation,{ 
                className : 'DCMB2B_checkoutPageCX', 
                updateAutoRenew : function(reqData, callback){ 
                    this.invokeCtx('updateAutoRenew',
                        reqData,
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                }
            });
            let isRefreshPayment = false;
            CCRZ.pubSub.on('view:PaymentProcessorView:refresh',function(paymentView){
                if(!isRefreshPayment){
                    paymentView.model.attributes.cartModel = CCRZ.cartCheckoutModel.attributes;
                    paymentView.events['change .cc_tc_terms'] = 'handleTermsCheck';
                    paymentView.postRender = function(){
                        $('.paymentTermsCheck.zindex20').click(function(){
                            let isCheck = $('.cc_tc_terms').is(':checked');
                            if(!isCheck){
                                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "storedpayment-messagingSection-Info", CCRZ.processPageLabelMap('KFB2B_Checkout_TermsError').toString()));
                                $('html, body').animate({
                                    'scrollTop' : $(".storedpayment-messagingSection-Info").position().top
                                });
                            }
                        });
                    };
                    paymentView.handleTermsCheck = function(event){
                        let checked = event.target.checked;
                        if(checked){
                            $('.paymentTermsCheck').removeClass('zindex20');
                            $('.storedpayment-messagingSection-Info').html('');
                            $('.storedpayment-messagingSection-Info').css('display', 'none');
                        } else {
                            $('.paymentTermsCheck').addClass('zindex20');
                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "storedpayment-messagingSection-Info", CCRZ.processPageLabelMap('KFB2B_Checkout_TermsError').toString()));
                            $('html, body').animate({
                                'scrollTop' : $(".storedpayment-messagingSection-Info").position().top
                            });
                        }
                    };
                    paymentView.useStoredPayment = function(event){
                        let isTcTerms = $('.cc_tc_terms').is(":checked");
                        if(isTcTerms){
                            if(!$("#storePaymentBtn").is(":disabled")) {
                                if(this.model.get("storedSelected")){
                                 $("#storePaymentBtn").attr("disabled", true);
                                 var storedPayment = this.model.get("storedSelected");
                                 _.each(this.model.get('storedPayments'),function(sp){
                                  if(sp.sfid == storedPayment){
                                   storedPayment = sp;
                                  }
                                 });
                                 UTIL.showLoader();
                                 CCRZ.pubSub.trigger("action:processPayment", {"storedPaymentId":storedPayment.sfid, "accountNumber":storedPayment.accountNumber, "accountType":storedPayment.accountType});
                                 if(CCRZ.ga){
                                  CCRZ.ga.handleSubmitOrder({'cartId': CCRZ.pagevars.currentCartID});
                                 }
                                }else{
                                 CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "storedpayment-messagingSection-Error", 'PaymentProcessor_InvalidPaymentId'));
                                }
                            }
                        } else {
                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "storedpayment-messagingSection-Info", CCRZ.processPageLabelMap('KFB2B_Checkout_TermsError').toString()));
                            $('html, body').animate({
                                'scrollTop' : $(".storedpayment-messagingSection-Info").position().top
                            });
                            setTimeout(function(){
                                $('.storedpayment-messagingSection-Info').css('display', 'none');
                            }, 5000);
                            UTIL.hideLoader();
                        }
                    }
                    paymentView.delegateEvents();
                    isRefreshPayment = true;
                    setTimeout(function(){
                        paymentView.render();
                    }, 1000);
                }
            });
            
            let isRendered = false;
            CCRZ.pubSub.on('view:cartCheckoutView:refresh',function(checkoutView){
                checkoutView.events['click .processBack'] = 'handleBack';
                checkoutView.handleBack = function(event){
                    $('#sidebarBackdrop').removeClass('hide');
                    nextIndex = this.currStep - 1;
                    if (!this.subViewArray[nextIndex] && nextIndex >= 0){
                    nextIndex--;
                    }
                    if(nextIndex >= 0){
                        window.location.href = CCRZ.pagevars.currentPageURL;
                    }else{
                        cartDetails();
                    }
                };
                checkoutView.loadDesktopView = function(){
                    let _this = this;
                    if (_this.subView)
                    _this.subView.setElement(this.$el);
                    else {
                        _this.subView = _this.subViewArray[0].view;
                        _this.subView.setElement(_this.$el);
                        if(_this.subView.initSetup){
                            _this.subView.initSetup(_.bind(_this.render, _this));
                        }
                    }
                    _this.subView.render();
                    _this.updateNav();
                    UTIL.hideLoader();
                };
                checkoutView.delegateEvents();
                if(CCRZ.cartCheckoutView.subViewArray && CCRZ.cartCheckoutView.subViewArray.length > 0){
                    let isShippingRemoved = false, isUserInfoRemoved = false;
                    let viewLength =  CCRZ.cartCheckoutView.subViewArray.length, newSubArray = [];
                    for(let i = 0; i <viewLength; i++) {
                        let currentSubView = CCRZ.cartCheckoutView.subViewArray[i];
                        if (i === 1 && typeof currentSubView == 'undefined') {
                            isShippingRemoved = true;
                        }
                        if (i === 0 && typeof currentSubView == 'undefined') {
                            isUserInfoRemoved = true;
                        }
                        if (typeof currentSubView != 'undefined'){
                            if (typeof currentSubView.title != 'undefined' &&
                                (currentSubView.title === 'Shipping' || currentSubView.title === 'User Information' || currentSubView.title === 'Order Review')) {
                                CCRZ.cartCheckoutView.removeView(i);
                            } else if (typeof currentSubView.title != 'undefined' && i === 2) {
                                CCRZ.cartCheckoutView.subView = CCRZ.cartCheckoutView.subViewArray[i].view;
                                newSubArray.push(CCRZ.cartCheckoutView.subViewArray[i]);
                            } else {
                                newSubArray.push(CCRZ.cartCheckoutView.subViewArray[i]);
                            }
                        }
                    }
                    if(!isShippingRemoved && !isUserInfoRemoved && !isRendered){
                        isRendered = true;
                        checkoutView.subViewArray = newSubArray;
                        checkoutView.navView.model.views = newSubArray;
                        checkoutView.lastIdx = newSubArray.length - 1;
                        checkoutView.navView.render();
                        checkoutView.subView = null;
                        UTIL.calculateSubscriptionPrices(checkoutView.model.attributes.cartItems, checkoutView, 'review');
                        checkoutView.render();
                    }
                }
            });
            CCRZ.pubSub.on('view:OrderReviewView:refresh',function(orderReview){
                orderReview.events['click .processReviewCustom'] = 'processCustomReview';
                orderReview.events['change .cc_tc_terms'] = 'handleTermsCheck';
                orderReview.events['change #autorenew'] = 'handleAutoRenewChange';
                orderReview.handleTermsCheck = function(event){
                    let checked = event.target.checked;
                    if(checked){
                        $('.cc_payment_types_container').removeClass('paymentBackdrop');
                        //$('.processReviewCustom').removeClass('disabled');

                    } else {
                        $('.cc_payment_types_container').addClass('paymentBackdrop');
                        //$('.processReviewCustom').addClass('disabled');
                    }
                };
                orderReview.processCustomReview = function(event){
                    let isSubscTerms = $('.cc_subsc_terms').is(":checked")
                    , isTcTerms = $('.cc_tc_terms').is(":checked");
                    //errorHandleCheckbox(isSubscTerms, '.cc_subsc_terms');
                    errorHandleCheckbox(isTcTerms, '.cc_tc_terms');
                    if(isTcTerms){
                        CCRZ.cartCheckoutView.slideRight();
                    } else {
                        $('')
                        console.log('error');
                    }
                }
                orderReview.handleAutoRenewChange = function(event){
                    let autoRenew = event.target.checked;
                    let reqData = { 'cartEncId' : CCRZ.pagevars.currentCartID, 'autoRenew' : autoRenew };
                    CCRZ.cartCheckoutModel.set('DCMAutoRenew', autoRenew);
                    $('#sidebarBackdrop').removeClass('hide');
                    CCRZ.remoteActions.checkoutPageRemoting.className = 'DCMB2B_checkoutPageCX';
                    CCRZ.remoteActions.checkoutPageRemoting.updateAutoRenew(JSON.stringify(reqData),function(res,evt){
                        if(res && res.success){
                            // Success Auto Renew
                        } else {
                            CCRZ.cartCheckoutModel.set('DCMAutoRenew', !autoRenew);
                            // Error on controller
                            console.log('ERROR: ' + res.data);
                        }
                        orderReview.render();
                        $('#sidebarBackdrop').addClass('hide');
                    }); 
                };
                orderReview.delegateEvents();
            });

            function errorHandleCheckbox(isCheck, checkElm){
                if(!isCheck){
                    $('.alertCheckbox').removeClass('hide');
                } else {
                    $('.alertCheckbox').addClass('hide');
                }
            }
        } 
        
    }
});

